void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->ADD10_OUT,0,retain)
  __INIT_VAR(data__->EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SEL15_OUT,0,retain)
  __INIT_VAR(data__->AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->ADD10_OUT,)));
  __SET_VAR(data__->,SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (UINT)__GET_VAR(data__->ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->SEL15_OUT,));
  __SET_VAR(data__->,AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void W_TO_B_ON_init__(W_TO_B_ON *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,0,retain)
  __INIT_VAR(data__->VAL_COMP,32753,retain)
  __INIT_VAR(data__->VAL0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT1,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void W_TO_B_ON_body__(W_TO_B_ON *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->IN0,) > __GET_VAR(data__->VAL_COMP,))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // W_TO_B_ON_body__() 





void B_TO_W_ON_init__(B_TO_W_ON *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL0,0,retain)
  __INIT_VAR(data__->OUT0,0,retain)
  __INIT_VAR(data__->OUT1,65535,retain)
  __INIT_VAR(data__->OUT,0,retain)
}

// Code part
void B_TO_W_ON_body__(B_TO_W_ON *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if (__GET_VAR(data__->IN0,)) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // B_TO_W_ON_body__() 





void UNO_CONVEYOR_init__(UNO_CONVEYOR *data__, BOOL retain) {
  __INIT_VAR(data__->OUT_3,0,retain)
  __INIT_VAR(data__->OUT_5,0,retain)
  __INIT_VAR(data__->OUT_4,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT_8,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->INP_A4,0,retain)
  __INIT_VAR(data__->INP_A5,0,retain)
  W_TO_B_ON_init__(&data__->W_TO_B_ON5,retain);
  TOF_init__(&data__->TOF0,retain);
  F_TRIG_init__(&data__->F_TRIG0,retain);
  B_TO_W_ON_init__(&data__->B_TO_W_ON0,retain);
  TOF_init__(&data__->TOF1,retain);
  F_TRIG_init__(&data__->F_TRIG1,retain);
  B_TO_W_ON_init__(&data__->B_TO_W_ON1,retain);
  W_TO_B_ON_init__(&data__->W_TO_B_ON6,retain);
  __INIT_VAR(data__->OR111_OUT,0,retain)
  __INIT_VAR(data__->NOT4_OUT,0,retain)
  __INIT_VAR(data__->WORD_TO_BOOL105_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void UNO_CONVEYOR_body__(UNO_CONVEYOR *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->,OUT_4,,__BOOL_LITERAL(TRUE));
  __SET_VAR(data__->,OR111_OUT,,OR__WORD__WORD(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (WORD)__GET_VAR(data__->OUT_3,),
    (WORD)__GET_VAR(data__->OUT_5,)));
  __SET_VAR(data__->,NOT4_OUT,,~(__GET_VAR(data__->OR111_OUT,)));
  __SET_VAR(data__->,WORD_TO_BOOL105_OUT,,WORD_TO_BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (WORD)__GET_VAR(data__->NOT4_OUT,)));
  __SET_VAR(data__->,OUT_8,,__GET_VAR(data__->WORD_TO_BOOL105_OUT,));
  __SET_VAR(data__->W_TO_B_ON6.,IN0,,__GET_VAR(data__->INP_A4,));
  W_TO_B_ON_body__(&data__->W_TO_B_ON6);
  __SET_VAR(data__->F_TRIG1.,CLK,,__GET_VAR(data__->W_TO_B_ON6.OUT,));
  F_TRIG_body__(&data__->F_TRIG1);
  __SET_VAR(data__->TOF1.,IN,,__GET_VAR(data__->F_TRIG1.Q,));
  __SET_VAR(data__->TOF1.,PT,,__time_to_timespec(1, 0, 2, 0, 0, 0));
  TOF_body__(&data__->TOF1);
  __SET_VAR(data__->B_TO_W_ON1.,IN0,,__GET_VAR(data__->TOF1.Q,));
  B_TO_W_ON_body__(&data__->B_TO_W_ON1);
  __SET_VAR(data__->,OUT_5,,__GET_VAR(data__->B_TO_W_ON1.OUT,));
  __SET_VAR(data__->W_TO_B_ON5.,IN0,,__GET_VAR(data__->INP_A5,));
  W_TO_B_ON_body__(&data__->W_TO_B_ON5);
  __SET_VAR(data__->F_TRIG0.,CLK,,__GET_VAR(data__->W_TO_B_ON5.OUT,));
  F_TRIG_body__(&data__->F_TRIG0);
  __SET_VAR(data__->TOF0.,IN,,__GET_VAR(data__->F_TRIG0.Q,));
  __SET_VAR(data__->TOF0.,PT,,__time_to_timespec(1, 0, 2, 0, 0, 0));
  TOF_body__(&data__->TOF0);
  __SET_VAR(data__->B_TO_W_ON0.,IN0,,__GET_VAR(data__->TOF0.Q,));
  B_TO_W_ON_body__(&data__->B_TO_W_ON0);
  __SET_VAR(data__->,OUT_3,,__GET_VAR(data__->B_TO_W_ON0.OUT,));

  goto __end;

__end:
  return;
} // UNO_CONVEYOR_body__() 





void W_TO_B_OFF_init__(W_TO_B_OFF *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,0,retain)
  __INIT_VAR(data__->VAL_COMP,32753,retain)
  __INIT_VAR(data__->VAL0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT1,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void W_TO_B_OFF_body__(W_TO_B_OFF *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->IN0,) < __GET_VAR(data__->VAL_COMP,))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // W_TO_B_OFF_body__() 





